#!/usr/bin/perl
##############################################################################
# WWWBoard                      Version 2.0 ALPHA 2                          #
# Copyright 1996 Matt Wright    mattw@worldwidemart.com                      #
# Created 10/21/95              Last Modified 11/25/95                       #
# Scripts Archive at:           http://www.worldwidemart.com/scripts/        #
##############################################################################
# COPYRIGHT NOTICE                                                           #
# Copyright 1996 Matthew M. Wright  All Rights Reserved.                     #
#                                                                            #
# WWWBoard may be used and modified free of charge by anyone so long as      #
# this copyright notice and the comments above remain intact.  By using this #
# code you agree to indemnify Matthew M. Wright from any liability that      #  
# might arise from it's use.                                                 #  
#                                                                            #
# Selling the code for this program without prior written consent is         #
# expressly forbidden.  In other words, please ask first before you try and  #
# make money off of my program.                                              #
#                                                                            #
# Obtain permission before redistributing this software over the Internet or #
# in any other medium.  In all cases copyright and header must remain intact.#
##############################################################################
# Define Variables

$basedir = "/home/httpd/html/cobalt/discuss/GROUP";
$basecgi = "/cgi-bin/cobalt/discuss/GROUP";
$baseurl = "/discuss/GROUP";
$cgi_url = "/cgi-bin/cobalt/discuss/GROUP/wwwboard.pl";

$basewrapper = "/cgi-bin/cobalt/discuss/GROUP/index.cgi";

$mesgdir = "private";
$datafile = "data.txt";
$mesgfile = "index.html";
$redfile = "redirect.html";
$faqfile = "faq.html";

$ext = "html";

$title = "CROUP Discussion";

# Done
###########################################################################

###########################################################################
# Configure Options

$show_faq = 0;		# 1 - YES; 0 = NO
$allow_html = 1;	# 1 = YES; 0 = NO
$quote_text = 1;	# 1 = YES; 0 = NO
$subject_line = 0;	# 0 = Quote Subject Editable; 1 = Quote Subject 
			#   UnEditable; 2 = Don't Quote Subject, Editable.
$use_time = 0;		# 1 = YES; 0 = NO

# Done
###########################################################################

# Get the Data Number
&get_number;

# Get Form Information
&parse_form;

# Put items into nice variables
&get_variables;

# Open the new file and write information to it.
&new_file;

# Open the Main WWWBoard File to add link
&main_page;

# Now Add Thread to Individual Pages
if ($num_followups >= 1) {
   &thread_pages;
}

# Return the user HTML
#&return_html;

# Increment Number
&increment_num;


print "location: $baseurl/$redfile\n\n";


############################
# Get Data Number Subroutine

sub get_number {
   open(NUMBER,"$basedir/$datafile");
   $num = <NUMBER>;
   close(NUMBER);
   if ($num == 99999)  {
      $num = "1";
   }
   else {
      $num++;
   }
}

#######################
# Parse Form Subroutine

sub parse_form {

   # Get the input
   read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});

   # Split the name-value pairs
   @pairs = split(/&/, $buffer);

   foreach $pair (@pairs) {
      ($name, $value) = split(/=/, $pair);

      # Un-Webify plus signs and %-encoding
      $value =~ tr/+/ /;
      $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
      $value =~ s/<!--(.|\n)*-->//g;

      if ($allow_html != 1) {
         $value =~ s/<([^>]|\n)*>//g;
      }
      else {
         unless ($name eq 'body') {
	    $value =~ s/<([^>]|\n)*>//g;
         }
      }

      $FORM{$name} = $value;
   }

}

###############
# Get Variables

sub get_variables {

   if ($FORM{'followup'}) {
      $followup = "1";
      @followup_num = split(/,/,$FORM{'followup'});
      $num_followups = @followups = @followup_num;
      $last_message = pop(@followups);
      $origdate = "$FORM{'origdate'}";
      $origname = "$FORM{'origname'}";
      $origsubject = "$FORM{'origsubject'}";
   }
   else {
      $followup = "0";
   }

   if ($FORM{'name'}) {
      $name = "$FORM{'name'}";
      $name =~ s/"//g;
      $name =~ s/<//g;
      $name =~ s/>//g;
      $name =~ s/\&//g;
   }
   else {
      &error(no_name);
   }

   if ($FORM{'email'} =~ /.*\@.*\..*/) {
      $email = "$FORM{'email'}";
   }

   if ($FORM{'subject'}) {
      $subject = "$FORM{'subject'}";
      $subject =~ s/\&/\&amp\;/g;
      $subject =~ s/"/\&quot\;/g;
      $subject =~ s/</&lt;/og; 
      $subject =~ s/>/&gt;/og; 
   }
   else {
      &error(no_subject);
   }

   if ($FORM{'url'} =~ /.*\:.*\..*/ && $FORM{'url_title'}) {
      $message_url = "$FORM{'url'}";
      $message_url_title = "$FORM{'url_title'}";
   }

   if ($FORM{'img'} =~ /.*tp:\/\/.*\..*/) {
      $message_img = "$FORM{'img'}";
   }

   if ($FORM{'body'}) {
      $body = "$FORM{'body'}";
      $body =~ s/\cM//og;
      #$body =~ s/&lt;/</og; 
      #$body =~ s/&gt;/>/og; 
      $body =~ s/</&lt;/og; 
      $body =~ s/>/&gt;/og; 
      $body =~ s/&quot;/"/og;

      $body =~ s/\n\n/<p>/og;
      $body =~ s/\n/<br>/og;
   }
   else {
      &error(no_body);
   }

   if ($quote_text == 1) {
      $hidden_body = "$body";
      $hidden_body =~ s/</&lt;/g;
      $hidden_body =~ s/>/&gt;/g;
      $hidden_body =~ s/"/&quot;/g;
   }

   ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime(time);

   if ($sec < 10) {
      $sec = "0$sec";
   }
   if ($min < 10) {
      $min = "0$min";
   }
   if ($hour < 10) {
      $hour = "0$hour";
   }
   if ($mon < 10) {
      $mon = "0$mon";
   }
   if ($mday < 10) {
      $mday = "0$mday";
   }

   $month = ($mon + 1);

   @months = ("January","February","March","April","May","June","July","August","September","October","November","December");

   if ($use_time == 1) {
      $date = "$hour\:$min\:$sec $month/$mday/$year";
   }
   else {
      $date = "$month/$mday/$year";
   }
   chop($date) if ($date =~ /\n$/);

# this line has problems after year 2000
#   $long_date = "$months[$mon] $mday, 19$year at $hour\:$min\:$sec";

    $realyear = $year + 1900;
    $long_date = "$months[$mon] $mday, $realyear at $hour\:$min\:$sec";

}      

#####################
# New File Subroutine

sub new_file {

   open(NEWFILE,">$basedir/$mesgdir/$num\.$ext") || die $!;
   open(FOLLOWUP,">$basedir/$mesgdir/$num\.fu\.$ext") || die $!;
   print NEWFILE "<html>\n";
   print NEWFILE "  <head>\n";
   print NEWFILE "<SCRIPT LANGUAGE=\"javascript\">\n";
   print NEWFILE "<!-- hide\n";
   print NEWFILE " var replyHelp=\"Submit a reply to this discussion message.\"\n";
   print NEWFILE " var topHelp=\"Return to the message list for this discussion.\"\n";
   print NEWFILE "// end hide -->\n"; 
   print NEWFILE "</SCRIPT>\n"; 

   print NEWFILE "    <title>$subject</title>\n";
   print NEWFILE "  </head>\n";
   print NEWFILE "  <body BGCOLOR=#FFFFFF>\n";
   print NEWFILE "    <center><P><BR>\n";
   print NEWFILE "<TABLE BORDER=\"1\" CELLSPACING=\"0\" WIDTH=\"95%\">\n";
   print NEWFILE "<TR><TD BGCOLOR=\"#6666CC\" NOWRAP><P ALIGN=\"CENTER\">";

   print NEWFILE "&nbsp;<FONT COLOR=\"#FFFFFF\" FACE=\"HELVETICA, ARIAL\"><B>$subject &nbsp;&nbsp;&nbsp;&nbsp;\n";
   print NEWFILE "<A HREF=\"javascript: top.showInfo( replyHelp );\" onMouseOver=\"window.status='help'; top.showInfo( replyHelp );\n";
   print NEWFILE " return true;\"><IMG SRC=\"/cobalt-images/question.gif\" WIDTH=\"20\" HEIGHT=\"20\" BORDER=\"0\"></A>&nbsp;\n";
   print NEWFILE "<a href=\"$basecgi/followup.sh\?$num\.fu\.$ext\">\n"; 
   print NEWFILE "<IMG SRC=\"/cobalt-images/reply_but.gif\" WIDTH=\"55\" HEIGHT=\"20\" BORDER=\"0\"></a>&nbsp;&nbsp;&nbsp;&nbsp;\n";
   print NEWFILE "<A HREF=\"javascript: top.showInfo( topHelp );\" onMouseOver=\"window.status='help'; top.showInfo( topHelp );\n";
   print NEWFILE " return true;\"><IMG SRC=\"/cobalt-images/question.gif\" WIDTH=\"20\" HEIGHT=\"20\" BORDER=\"0\"></A>&nbsp;\n";
   print NEWFILE "<A HREF=\"$basewrapper/\"><IMG SRC=\"/cobalt-images/dis_top_but.gif\" WIDTH=\"125\" HEIGHT=\"20\" BORDER=\"0\"></B></FONT></A>\n";
   print NEWFILE "</TD></TR>"; 
   print NEWFILE "<TR><TD><P ALIGN=\"CENTER\">Posted by ";

   if ($email) {
      print NEWFILE "$name on $long_date\n";
   }
   else {
      print NEWFILE "$name on $long_date\n";
   }

   print NEWFILE "</TD></TR>"; 

   if ($followup == 1) {
   print NEWFILE "<TR><TD><P ALIGN=\"CENTER\">";
      print NEWFILE "In Reply to: <a href=\"$last_message\.$ext\">$origsubject</a> posted by ";

      if ($origemail) {
         print NEWFILE "$origname on $origdate:<p>\n";
      }
      else {
         print NEWFILE "$origname on $origdate:<p>\n";
      }
   print NEWFILE "</TD></TR>"; 
   }

   print NEWFILE "<TR><TD HEIGHT=\"47\"><CENTER><P><TABLE BORDER=\"0\" CELLPADDING=\"0\" CELLSPACING=\"0\" WIDTH=\"90%\">\n"; 
   print NEWFILE "<TR><TD BGCOLOR=\"#FFFFFF\">$body</TD></TR>\n";
   print NEWFILE "</TABLE></CENTER>\n";
   print NEWFILE "</TD></TR>"; 
   print NEWFILE "<TR><TD><BLOCKQUOTE><P><BR>\n"; 
   if ($message_url) {
      print NEWFILE "<ul><li><a href=\"$message_url\">$message_url_title</a></ul>\n";
   }
   print NEWFILE "<a name=\"followups\">Replies:</a>\n";
   print NEWFILE "<ul><!--insert: $num-->\n";
   print NEWFILE "</ul><!--end: $num-->\n";
   print NEWFILE "</BLOCKQUOTE></TD></TR></TABLE></CENTER>\n"; 

   # Make followup response form...

   print FOLLOWUP "<html>\n";
   print FOLLOWUP "  <head>\n";
   print FOLLOWUP "    <title>Reply</title>\n";
   print FOLLOWUP "  </head>\n";
   print FOLLOWUP "  <body BGCOLOR=#FFFFFF>\n";
   print FOLLOWUP "<form method=POST action=\"$cgi_url\">\n";
   print FOLLOWUP "    <center>\n";
   print FOLLOWUP "<input type=hidden name=\"followup\" value=\"";
   if ($followup == 1) {
      foreach $followup_num (@followup_num) {
         print FOLLOWUP "$followup_num,";
      }
   }
   print FOLLOWUP "$num\">\n";
   print FOLLOWUP "<input type=hidden name=\"origname\" value=\"$name\">\n";
   if ($email) {
      print FOLLOWUP "<input type=hidden name=\"origemail\" value=\"$email\">\n";
   }
   print FOLLOWUP "<input type=hidden name=\"origsubject\" value=\"$subject\">\n";
   print FOLLOWUP "<input type=hidden name=\"origdate\" value=\"$long_date\">\n";
   print FOLLOWUP " <TABLE BORDER=\"1\" WIDTH=\"95%\">";
   print FOLLOWUP "  <TR>";
   print FOLLOWUP "          <TD COLSPAN=\"2\" BGCOLOR=\"#6666CC\">";
   print FOLLOWUP " <P ALIGN=\"CENTER\">";
   print FOLLOWUP " <FONT COLOR=\"#FFFFFF\" FACE=\"HELVETICA, ARIAL\"><B>Reply To:  $subject</B></FONT>\n ";
   print FOLLOWUP "          </TD>";
   print FOLLOWUP "   </TR>";
   print FOLLOWUP "  <TR>";
   print FOLLOWUP "         <TD>Name</TD>";
   print FOLLOWUP "          <TD WIDTH=\"486\"><INPUT TYPE=\"HIDDEN\" NAME=\"name\" SIZE=\"-1\" VALUE=\"XXXNAME\">XXXNAME</TD>\n";
   print FOLLOWUP "  </TR>";
   print FOLLOWUP "  <TR>";
   print FOLLOWUP "         <TD>Email</TD>";
   print FOLLOWUP "          <TD WIDTH=\"486\"><INPUT TYPE=\"HIDDEN\" NAME=\"email\" SIZE=\"-1\" VALUE=\"XXXEMAIL\">XXXEMAIL</TD>\n";
   print FOLLOWUP "  </TR>";
   
   if ($subject_line == 1) {
      if ($subject_line =~ /^Re:/) {
         print FOLLOWUP "<input type=hidden name=\"subject\"  SIZE=\"55\" value=\"$subject\">\n";
         print FOLLOWUP "<TR><TD>Subject</TD><TD WIDTH=\"486\"> <b>$subject</b></TD></TR>\n";
      }
      else {
         print FOLLOWUP "<input type=hidden name=\"subject\" SIZE=\"55\" value=\"Re: $subject\">\n";
         print FOLLOWUP "<TR><TD>Subject</TD><TD WIDTH=\"486\"><b>Re: $subject</b></TD></TR>\n";
      }
   } 
   elsif ($subject_line == 2) {
      print FOLLOWUP "<TR><TD>Subject</TD><TD WIDTH=\"486\"><input type=text name=\"subject\" size=55></TD></TR>\n";
   }
   else {
      if ($subject =~ /^Re:/) {
         print FOLLOWUP "<TR><TD>Subject</TD><TD WIDTH=\"486\"><input type=text name=\"subject\"value=\"$subject\" size=55></TD></TR>\n";
      }
      else {
         print FOLLOWUP "<TR><TD>Subject</TD><TD WIDTH=\"486\"><input type=text name=\"subject\" value=\"Re: $subject\" size=55></TD></TR>\n";
      }
   }
   print FOLLOWUP "<TR><TD>Comments</TD><TD WIDTH=\"486\">\n";
   print FOLLOWUP "<textarea name=\"body\" COLS=60 ROWS=10 wrap=soft>\n";
   if ($quote_text == 1) {
      @chunks_of_body = split(/\&lt\;p\&gt\;/,$hidden_body);
      foreach $chunk_of_body (@chunks_of_body) {
         @lines_of_body = split(/\&lt\;br\&gt\;/,$chunk_of_body);
         foreach $line_of_body (@lines_of_body) {
            print FOLLOWUP ": $line_of_body\n";
         }
         print FOLLOWUP "\n";
      }
   }
   print FOLLOWUP "</textarea></TD></TR>\n";
   print FOLLOWUP "\n";
   print FOLLOWUP "</TABLE><BR>";

   print FOLLOWUP "<A HREF=\"javascript: document.forms[ 0 ].submit();\" onMouseOver=\"status='Submit a Reply';\">";
   print FOLLOWUP "<IMG SRC=\"/cobalt-images/submit_but.gif\" WIDTH=67 HEIGHT=20 BORDER=0></A>&nbsp;";
   print FOLLOWUP "<A HREF=\"$basewrapper/\"><IMG SRC=\"/cobalt-images/cancel_but.gif\" WIDTH=67 HEIGHT=20 BORDER=0></A>";

   print FOLLOWUP "    </center>\n";
   print FOLLOWUP "</body></html>\n";


   print NEWFILE "</body></html>\n";

   close(FOLLOWUP);
   close(NEWFILE);
}

###############################
# Main WWWBoard Page Subroutine

sub main_page {
   open(MAIN,"$basedir/$mesgfile") || die $!;
   @main = <MAIN>;
   close(MAIN);

   open(MAIN,">$basedir/$mesgfile") || die $!;
   if ($followup == 0) {
      foreach $main_line (@main) {
         if ($main_line =~ /<!--begin-->/) {
            print MAIN "<!--begin-->\n";
	    print MAIN "<!--top: $num--><li><a href=\"$baseurl/$mesgdir/$num\.$ext\">$subject</a> - <b>$name</b> <i>$date</i><HR>\n";
            print MAIN "<!--responses: $num-->\n";
            print MAIN "<ul><!--insert: $num-->\n";
            print MAIN "</ul><!--end: $num-->\n";
         }
         else {
            print MAIN "$main_line";
         }
      }
   }
   else {
      foreach $main_line (@main) {
	 $work = 0;
         if ($main_line =~ /<ul><!--insert: $last_message-->/) {
            print MAIN "<ul><!--insert: $last_message-->\n";
            print MAIN "<!--top: $num--><li><a href=\"$baseurl/$mesgdir/$num\.$ext\">$subject</a> - <b>$name</b> <i>$date</i><HR>\n";
            print MAIN "<!--responses: $num-->\n";
            print MAIN "<ul><!--insert: $num-->\n";
            print MAIN "</ul><!--end: $num-->\n";
         }
         elsif ($main_line =~ /\(<!--responses: (.*)-->(.*)\)/) {
            $response_num = $1;
            $num_responses = $2;
            $num_responses++;
            foreach $followup_num (@followup_num) {
               if ($followup_num == $response_num) {
                  print MAIN "<!--responses: $followup_num-->\n";
		  $work = 1;
               }
            }
            if ($work != 1) {
               print MAIN "$main_line";
            }
         }
         else {
            print MAIN "$main_line";
         }
      }
   }
   close(MAIN);
}

############################################
# Add Followup Threading to Individual Pages
sub thread_pages {

   foreach $followup_num (@followup_num) {
      open(FOLLOWUP,"$basedir/$mesgdir/$followup_num\.$ext");
      @followup_lines = <FOLLOWUP>;
      close(FOLLOWUP);

      open(FOLLOWUP,">$basedir/$mesgdir/$followup_num\.$ext");
      foreach $followup_line (@followup_lines) {
         $work = 0;
         if ($followup_line =~ /<ul><!--insert: $last_message-->/) {
	    print FOLLOWUP "<ul><!--insert: $last_message-->\n";
            print FOLLOWUP "<!--top: $num--><li><a href=\"$num\.$ext\">$subject</a> <b>$name</b> <i>$date</i>\n";
            print FOLLOWUP "<HR><!--responses: $num-->\n";
            print FOLLOWUP "<ul><!--insert: $num-->\n";
            print FOLLOWUP "</ul><!--end: $num-->\n";
         }
         elsif ($followup_line =~ /\(<!--responses: (.*)-->(.*)\)/) {
            $response_num = $1;
            $num_responses = $2;
            $num_responses++;
            foreach $followup_num (@followup_num) {
               if ($followup_num == $response_num) {
                  print FOLLOWUP "<HR><!--responses: $followup_num-->\n";
                  $work = 1;
               }
            }
            if ($work != 1) {
               print FOLLOWUP "$followup_line";
            }
         }
         else {
            print FOLLOWUP "$followup_line";
         }
      }
      close(FOLLOWUP);
   } 


}

sub return_html {

   print "Content-type: text/html\n\n";
   print "<html><head><title>Message Added: $subject</title></head>\n";
   print "<body BGCOLOR=#FFFFFF><center><FONT FACE=\"HELVETICA, ARIAL\"><B>MESSAGE ADDED:  $subject</B></FONT></center>\n";

   print "<center>";
   print "<p>The following information was added to the message board:<br><br>\n";
   print "<TABLE WIDTH=100%><TR><TD BGCOLOR=#CCCCFF>";
   print "<TABLE WIDTH=100%><TR><TD BGCOLOR=#CCCCFF>";
   print "<b>Name:</b> $name<br>\n";
   print "<b>Email:</b> $email<br>\n";
   print "<b>Subject:</b> $subject<br>\n";
   print "<b>Body of Message:</b><p>\n";
   print "$body<p>\n";
   if ($message_url) {
      print "<b>Link:</b> <a href=\"$message_url\">$message_url_title</a><br>\n";
   }
   if ($message_img) {
      print "<b>Image:</b> <img src=\"$message_img\"><br>\n";
   }
   print "<b>Added on Date:</b> $date<p>\n";
   print "\n";
   print "</TD></TR></TABLE>";
   print "</TD></TR></TABLE>";
   print "<br><br>";
   print "[ <a href=\"$baseurl/$mesgdir/$num\.$ext\">Go to Your Message</a> ] [ <a href=\"$basewrapper\">$title</a> ] </center>\n";
   print "</body></html>\n";
}

sub increment_num {
   open(NUM,">$basedir/$datafile") || die $!;
   print NUM "$num";
   close(NUM);
}

sub error {
   $error = $_[0];

   print "Content-type: text/html\n\n";

   if ($error eq 'no_name') {
      print "<html><head><title>$title ERROR: No Name</title><SCRIPT LANGUAGE=\"javascript\">top.showInfo( '<IMG SRC=\"/cobalt-images/bang.gif\" ALIGN=CENTER> The name field was left blank.  Please enter your name and Submit the message again.' );</SCRIPT></head><body BGCOLOR=#FFFFFF><CENTER>\n";
      print " <TABLE BORDER=\"1\" WIDTH=\"95%\">";
      print "  <TR>";
      print "          <TD COLSPAN=\"2\" BGCOLOR=\"#6666CC\">";
      print "<P ALIGN=\"CENTER\"> <FONT COLOR=\"#FFFFFF\" FONT FACE=\"HELVETICA, ARIAL\"><B>ERROR:  No Name</B></FONT>\n";
      print "</TD></TR>";
#      print "<p>You forgot to fill in the 'Name' field in your posting.  Correct it below and re-submit.  The necessary fields are: Name, Subject and Message.<p><p>\n";
      &rest_of_form;
   }
   elsif ($error eq 'no_subject') {
      print "<html><head><title>$title ERROR: No Subject</title><SCRIPT LANGUAGE=\"javascript\">top.showInfo( '<IMG SRC=\"/cobalt-images/bang.gif\" ALIGN=CENTER> The subject field was left blank.  Please enter a subject and Submit the message again.' );</SCRIPT></head><body BGCOLOR=#FFFFFF><CENTER>\n";
      print " <TABLE BORDER=\"1\" WIDTH=\"95%\">";
      print "  <TR>";
      print "          <TD COLSPAN=\"2\" BGCOLOR=\"#6666CC\">";
      print "<P ALIGN=\"CENTER\"> <FONT COLOR=\"#FFFFFF\" FONT FACE=\"HELVETICA, ARIAL\"><B>ERROR:  No Subject</B></FONT>\n";
      print "</TD></TR>";
#      print "<p>You forgot to fill in the 'Subject' field in your posting.  Correct it below and re-submit.  The necessary fields are: Name, Subject and Message.<p><p>\n";
      &rest_of_form;
   }
   elsif ($error eq 'no_body') {
      print "<html><head><title>$title ERROR: No Message</title><SCRIPT LANGUAGE=\"javascript\">top.showInfo( '<IMG SRC=\"/cobalt-images/bang.gif\" ALIGN=CENTER> The message field was left blank.  Please enter a message and Submit the message again.' );</SCRIPT></head><body BGCOLOR=#FFFFFF><CENTER>\n";
      print " <TABLE BORDER=\"1\" WIDTH=\"95%\">";
      print "  <TR>";
      print "          <TD COLSPAN=\"2\" BGCOLOR=\"#6666CC\">";
      print "<P ALIGN=\"CENTER\"><FONT COLOR=\"#FFFFFF\" FONT FACE=\"HELVETICA, ARIAL\"><B>ERROR:  No Message</B></FONT>\n";
      print "</TD></TR>";
#      print "<p>You forgot to fill in the 'Message' fieldin your posting.  Correct it below and re-submit.  The necessary fields are: Name, Subjectand Message.<p><p>\n";
      &rest_of_form;
   }
   else {
      print "ERROR!  Undefined.\n";
   }
   exit;
}

sub rest_of_form {

   print "<form method=POST action=\"$cgi_url\">\n";

   if ($followup == 1) {
      print "<input type=hidden name=\"origsubject\" value=\"$FORM{'origsubject'}\">\n";
      print "<input type=hidden name=\"origname\" value=\"$FORM{'origname'}\">\n";
      print "<input type=hidden name=\"origemail\" value=\"$FORM{'origemail'}\">\n";
      print "<input type=hidden name=\"origdate\" value=\"$FORM{'origdate'}\">\n";
      print "<input type=hidden name=\"followup\" value=\"$FORM{'followup'}\">\n";
   }
   print "<TR><TD>Name</TD><TD WIDTH=\"486\"> <input type=hidden name=\"name\" value=\"$FORM{'name'}\" size=\"-1\">$FORM{'name'}</TD></TR>\n";
   print "<TR><TD>Email</TD><TD WIDTH=\"486\"> <input type=hidden name=\"email\" value=\"$FORM{'email'}\" size=\"-1\">$FORM{'email'}</TD></TR>\n";
   if ($subject_line == 1) {
      print "<input type=hidden name=\"subject\"  SIZE=\"55\"  value=\"$FORM{'subject'}\">\n";
      print "<TR><TD>Subject</TD><TD WIDTH=\"486\"> <b>$FORM{'subject'}</b></TD></TR>\n";
   } 
   else {
      print "<TR><TD>Subject</TD><TD WIDTH=\"486\"> <input type=text name=\"subject\" value=\"$FORM{'subject'}\" size=55></TD></TR>\n";
   }
   print "<TR><TD>Message</TD><TD WIDTH=\"486\">\n";
   print "<textarea COLS=60 ROWS=10 wrap=soft name=\"body\">\n";
   $FORM{'body'} =~ s/</&lt;/g;
   $FORM{'body'} =~ s/>/&gt;/g;
   $FORM{'body'} =~ s/"/&quot;/g;
   print "$FORM{'body'}\n";
   print "</textarea></TD></TR>\n";
   print "</TABLE><BR>";

   print "<A HREF=\"javascript: document.forms[ 0 ].submit();\" onMouseOver=\"status='Post Message';\">";
   print "<IMG SRC=\"/cobalt-images/submit_but.gif\" WIDTH=67 HEIGHT=20 BORDER=0></A>&nbsp;";
   print "<A HREF=\"$basewrapper/\"><IMG SRC=\"/cobalt-images/cancel_but.gif\" WIDTH=67 HEIGHT=20 BORDER=0></A>";

   print "</form>\n";
   print "</center>";
   print "</body></html>\n";
}
